﻿#define USE_TLS1

using System;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        EventWaitHandle ewh = new EventWaitHandle(false, EventResetMode.ManualReset);

        for (int i = 0; i < 10; i++)
        {
            ThreadPool.QueueUserWorkItem(workItem, ewh);
            ewh.WaitOne();
            ewh.Reset();
        }
    }

#if USE_TLS
    private static void workItem(object state)
    {
        EventWaitHandle ewh = state as EventWaitHandle;

        if (MyType.Text == null)
        {
            MyType.Text = $"New: " + Environment.CurrentManagedThreadId;
        }
        else
        {
            MyType.Text = $"Old: " + MyType.Text;
        }

        string text = MyType.Text;
        Console.WriteLine($"{Environment.CurrentManagedThreadId}: {text}");

        ewh.Set();
    }
#else
    private static void workItem(object state)
    {
        EventWaitHandle ewh = state as EventWaitHandle;

        if (MyType.Text.Value == null)
        {
            MyType.Text.Value = $"New: " + Environment.CurrentManagedThreadId;
        }
        else
        {
            MyType.Text.Value = $"Old: " + MyType.Text.Value;
        }

        Console.WriteLine($"{Environment.CurrentManagedThreadId}: {MyType.Text.Value}");

        ewh.Set();
    }
#endif
}

class MyType
{
#if USE_TLS
    [ThreadStatic]
    public static string Text;
#else
    public static AsyncLocal<string> Text = new AsyncLocal<string>();
#endif
}